Index: issm/trunk/jenkins/macosx_pine-island_dakota
===================================================================
--- issm/trunk/jenkins/macosx_pine-island_dakota	(revision 23389)
+++ issm/trunk/jenkins/macosx_pine-island_dakota	(revision 23394)
@@ -5,9 +5,11 @@
 
 #MATLAB path
-MATLAB_PATH="/Applications/MATLAB_R2015b.app/"
+MATLAB_PATH="/Applications/MATLAB_R2015b.app"
 
-#ISSM CONFIGURATION 
+#ISSM CONFIGURATION
 ISSM_CONFIG='--prefix=$ISSM_DIR \
 	--with-matlab-dir=$MATLAB_PATH \
+	--with-python-dir=/System/Library/Frameworks/Python.framework/Versions/2.7 \
+	--with-python-numpy-dir=/System/Library/Frameworks/Python.framework/Versions/2.7/Extras/lib/python/numpy \
 	--with-triangle-dir=$ISSM_DIR/externalpackages/triangle/install \
 	--with-mpi-include=$ISSM_DIR/externalpackages/mpich/install/include  \
@@ -27,5 +29,5 @@
 #PYTHON and MATLAB testing
 MATLAB_TEST=1
-PYTHON_TEST=0
+PYTHON_TEST=1
 
 #-----------------------------------#
@@ -54,10 +56,10 @@
 
 #number of cpus used in the nightly runs.
-NUMCPUS_RUN=2
+NUMCPUS_RUN=4
 
 #Nightly run options. The matlab routine runme.m will be called
 #as follows: runme($MATLAB_NROPTIONS). The options must be understandable
 #by Matlab and runme.m
-#ex: "'id',[101 102 103]"  ERRORS ARE LARGE FOR: 418 420 
-PYTHON_NROPTIONS=""
+#ex: "'id',[101 102 103]"  ERRORS ARE LARGE FOR: 418 420
+PYTHON_NROPTIONS="--exclude 119 243 514 701 702 703 234 235 418 420 --include_name 'Dakota'"
 MATLAB_NROPTIONS="'exclude',[119,243,514,701,702,703,234,235,418,420]"
Index: issm/trunk/jenkins/macosx_pine-island_dakota_static
===================================================================
--- issm/trunk/jenkins/macosx_pine-island_dakota_static	(revision 23389)
+++ issm/trunk/jenkins/macosx_pine-island_dakota_static	(revision 23394)
@@ -4,7 +4,7 @@
 
 #MATLAB path
-MATLAB_PATH="/Applications/MATLAB_R2015b.app/"
+MATLAB_PATH="/Applications/MATLAB_R2015b.app"
 
-#ISSM CONFIGURATION 
+#ISSM CONFIGURATION
 ISSM_CONFIG='--prefix=$ISSM_DIR \
 	--disable-static \
@@ -56,5 +56,5 @@
 
 #number of cpus used in the nightly runs.
-NUMCPUS_RUN=2
+NUMCPUS_RUN=4
 
 #Nightly run options. The matlab routine runme.m will be called
@@ -62,5 +62,5 @@
 #by Matlab and runme.m
 #ex: "'id',[101 102 103]"
-##                           bamg mesh   FS                     
+##                           bamg mesh   FS
 #PYTHON_NROPTIONS="--exclude_name 'Dakota'"
 #MATLAB_NROPTIONS="'exclude',[243,701,702,703,435,IdFromString('Dakota')]"
Index: issm/trunk/jenkins/macosx_pine-island_examples
===================================================================
--- issm/trunk/jenkins/macosx_pine-island_examples	(revision 23389)
+++ issm/trunk/jenkins/macosx_pine-island_examples	(revision 23394)
@@ -5,7 +5,7 @@
 
 #MATLAB path
-MATLAB_PATH="/Applications/MATLAB_R2015b.app/"
+MATLAB_PATH="/Applications/MATLAB_R2015b.app"
 
-#ISSM CONFIGURATION 
+#ISSM CONFIGURATION
 ISSM_CONFIG='--prefix=$ISSM_DIR \
 	--with-matlab-dir=$MATLAB_PATH \
Index: issm/trunk/m4/issm_options.m4
===================================================================
--- issm/trunk/m4/issm_options.m4	(revision 23389)
+++ issm/trunk/m4/issm_options.m4	(revision 23394)
@@ -9,5 +9,5 @@
 	dnl ISSM's internal options
 	dnl Build info{{{
-	
+
 	dnl build date
 	AC_PATH_PROGS(DATE, date)
@@ -153,5 +153,5 @@
 	AC_MSG_CHECKING(for wrappers compilation)
 	AM_CONDITIONAL([WRAPPERS], [test x$WRAPPERS_VALUE = xyes])
-	AC_MSG_RESULT($WRAPPERS_VALUE) 
+	AC_MSG_RESULT($WRAPPERS_VALUE)
 	dnl }}}
 	dnl Extensions{{{
@@ -251,5 +251,5 @@
 		fi
 	fi
-	AC_SUBST([OSLIBS]) 
+	AC_SUBST([OSLIBS])
 	AC_MSG_RESULT(done)
 	dnl }}}
@@ -281,21 +281,21 @@
 
 		AC_DEFINE([_HAVE_MATLAB_],[1],[with matlab in ISSM src])
-		
+
 		dnl 4. get MEXLIB MEXLINK and MEXEXT (experimental) except for windows
 		AC_MSG_CHECKING([matlab's mex compilation flags])
   		case "${host_os}" in
-  			*cygwin*) 
+  			*cygwin*)
   				if  test $VENDOR = intel-win7-32; then
-  					MEXLIB="-Wl,libmx.lib -Wl,libmex.lib -Wl,libmat.lib ${OSLIBS} -Wl,libf2cblas.lib -Wl,libf2clapack.lib" 
+  					MEXLIB="-Wl,libmx.lib -Wl,libmex.lib -Wl,libmat.lib ${OSLIBS} -Wl,libf2cblas.lib -Wl,libf2clapack.lib"
                MEXLINK="-Wl,/LIBPATH:`cygpath -m ${MATLAB_ROOT}/extern/lib/win32/microsoft` -Wl,/link -Wl,/EXPORT:mexFunction -Wl,/DLL"
 					MEXEXT=`$MATLAB_ROOT/bin/mexext.bat`
 					MEXEXT=".$MEXEXT"
   				elif test $VENDOR = intel-win7-64; then
-  					MEXLIB="-Wl,libmx.lib -Wl,libmex.lib -Wl,libmat.lib ${OSLIBS} -Wl,libf2cblas.lib -Wl,libf2clapack.lib" 
-               MEXLINK="-Wl,/LIBPATH:`cygpath -m ${MATLAB_ROOT}/extern/lib/win64/microsoft` -Wl,/link -Wl,/EXPORT:mexFunction -Wl,/DLL" 
+  					MEXLIB="-Wl,libmx.lib -Wl,libmex.lib -Wl,libmat.lib ${OSLIBS} -Wl,libf2cblas.lib -Wl,libf2clapack.lib"
+               MEXLINK="-Wl,/LIBPATH:`cygpath -m ${MATLAB_ROOT}/extern/lib/win64/microsoft` -Wl,/link -Wl,/EXPORT:mexFunction -Wl,/DLL"
 					MEXEXT=".mexw64"
   				elif test $VENDOR = MSVC-Win64 || test $VENDOR = MSVC-Win64-par; then
-  					MEXLIB="-Wl,libmx.lib -Wl,libmex.lib -Wl,libmat.lib ${OSLIBS} -Wl,libf2cblas.lib -Wl,libf2clapack.lib" 
-               MEXLINK="-Wl,/link -Wl,/LIBPATH:`cygpath -m ${MATLAB_ROOT}/extern/lib/win64/microsoft` -Wl,/link -Wl,/EXPORT:mexFunction -Wl,/DLL" 
+  					MEXLIB="-Wl,libmx.lib -Wl,libmex.lib -Wl,libmat.lib ${OSLIBS} -Wl,libf2cblas.lib -Wl,libf2clapack.lib"
+               MEXLINK="-Wl,/link -Wl,/LIBPATH:`cygpath -m ${MATLAB_ROOT}/extern/lib/win64/microsoft` -Wl,/link -Wl,/EXPORT:mexFunction -Wl,/DLL"
   					MATLABINCL="-I`cygpath -m $MATLAB_ROOT/extern/include/`"
 					MEXEXT=".mexw64"
@@ -311,5 +311,5 @@
 					 echo "#include <mex.h>" > conftest.cpp
 					 echo "void mexFunction(int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){}" >> conftest.cpp
-					 $MATLAB_ROOT/bin/mex -v -lmex conftest.cpp > conftest.tmp 2>&1 
+					 $MATLAB_ROOT/bin/mex -v -lmex conftest.cpp > conftest.tmp 2>&1
 					 rm -f conftest.cpp
 					 MEXLINK=$(cat conftest.tmp | grep LDFLAGS  | sed -e "s/LDFLAGS ://g")
@@ -333,5 +333,5 @@
 		MATLABWRAPPEREXT=$MEXEXT
 		AC_SUBST([MATLABWRAPPEREXT])
-	   AC_SUBST([MEXLIB]) 
+	   AC_SUBST([MEXLIB])
 		AC_SUBST([MEXLINK])
 	fi
@@ -345,5 +345,5 @@
 	AC_ARG_WITH([javascript],
 	  AS_HELP_STRING([--with-javascript], [compile javascript wrappers? default is no.]),
-	  [JAVASCRIPT=$withval],[JAVASCRIPT="no"]) 
+	  [JAVASCRIPT=$withval],[JAVASCRIPT="no"])
 
 	dnl Check whether javascript wrappers are desired
@@ -364,5 +364,5 @@
 	AC_ARG_WITH([triangle-dir],
 			  AS_HELP_STRING([--with-triangle-dir=DIR], [triangle root directory.]),
-			 [TRIANGLE_ROOT=$withval],[TRIANGLE_ROOT="no"]) 
+			 [TRIANGLE_ROOT=$withval],[TRIANGLE_ROOT="no"])
 
   dnl Check whether triangle is enabled
@@ -394,5 +394,5 @@
 				if test "x$HAVE_JAVASCRIPT" = "xyes"; then
 					dnl go to the bit code, not the library.
-					TRIANGLELIB=$TRIANGLE_ROOT/triangle.o 
+					TRIANGLELIB=$TRIANGLE_ROOT/triangle.o
 				else
 					TRIANGLELIB=$TRIANGLE_ROOT/triangle.a
@@ -402,5 +402,5 @@
 				if test "x$HAVE_JAVASCRIPT" = "xyes"; then
 					dnl go to the bit code, not the library.
-					TRIANGLELIB=$TRIANGLE_ROOT/triangle.o 
+					TRIANGLELIB=$TRIANGLE_ROOT/triangle.o
 				else
 					TRIANGLELIB=$TRIANGLE_ROOT/triangle.a
@@ -416,5 +416,5 @@
 	AC_ARG_WITH([boost-dir],
 	  AS_HELP_STRING([--with-boost-dir=DIR], [boost root directory.]),
-	  [BOOST_ROOT=$withval],[BOOST_ROOT="no"]) 
+	  [BOOST_ROOT=$withval],[BOOST_ROOT="no"])
 
 	dnl Check whether boost is enabled
@@ -443,6 +443,6 @@
 	AC_ARG_WITH([dakota-dir],
 	  AS_HELP_STRING([--with-dakota-dir=DIR], [dakota root directory.]),
-	  [DAKOTA_ROOT=$withval],[DAKOTA_ROOT="no"]) 
-	
+	  [DAKOTA_ROOT=$withval],[DAKOTA_ROOT="no"])
+
 	dnl Check whether dakota is enabled
 	AC_MSG_CHECKING([for dakota])
@@ -573,5 +573,5 @@
 	AC_ARG_WITH([python-dir],
 	  AS_HELP_STRING([--with-python-dir=DIR], [python root directory.]),
-	  [PYTHON_ROOT=$withval],[PYTHON_ROOT="no"]) 
+	  [PYTHON_ROOT=$withval],[PYTHON_ROOT="no"])
 
 	dnl Check whether python is enabled
@@ -592,10 +592,10 @@
 	if test "x$HAVE_PYTHON" = "xyes"; then
 		AC_MSG_CHECKING([for python version])
-		dnl Query Python for its version number.  Getting [:3] seems to be the
+		dnl Query Python for its version number. Getting [:3] seems to be the
 		dnl best way to do this; it's what "site.py" does in the standard library.
 		PYTHON_VERSION=$($PYTHON_ROOT/bin/python -c "import sys; print sys.version[[:3]]")
 		AC_MSG_RESULT($PYTHON_VERSION)
 
-		dnl recover major 
+		dnl recover major
 		PYTHON_MAJOR=${PYTHON_VERSION%.*}
 		AC_DEFINE_UNQUOTED([_PYTHON_MAJOR_],$PYTHON_MAJOR,[python version major])
@@ -643,6 +643,11 @@
 	AC_ARG_WITH([python-numpy-dir],
 	  AS_HELP_STRING([--with-python-numpy-dir=DIR], [python-numpy root directory.]),
-	  [PYTHON_NUMPY_ROOT=$withval],[PYTHON_NUMPY_ROOT="no"]) 
-	
+	  [PYTHON_NUMPY_ROOT=$withval],[PYTHON_NUMPY_ROOT="no"])
+
+	dnl you can find numpy by typing
+	dnl >>> import numpy
+	dnl >>> numpy.__file__
+	dnl '/System/Library/Frameworks/Python.framework/Versions/2.7/Extras/lib/python/numpy/__init__.pyc'
+
 	dnl Check whether numpy is enabled
 	AC_MSG_CHECKING(for python-numpy)
@@ -667,6 +672,6 @@
 	AC_ARG_WITH([chaco-dir],
 	  AS_HELP_STRING([--with-chaco-dir=DIR], [chaco root directory.]),
-	  [CHACO_ROOT=$withval],[CHACO_ROOT="no"]) 
-	
+	  [CHACO_ROOT=$withval],[CHACO_ROOT="no"])
+
 	dnl Check whether chaco is enabled
 	AC_MSG_CHECKING([for chaco])
@@ -694,5 +699,5 @@
 	AC_ARG_WITH([scotch-dir],
 	  AS_HELP_STRING([--with-scotch-dir=DIR], [scotch root directory.]),
-	  [SCOTCH_ROOT=$withval],[SCOTCH_ROOT="no"]) 
+	  [SCOTCH_ROOT=$withval],[SCOTCH_ROOT="no"])
 
   dnl Check whether scotch is enabled
@@ -708,5 +713,5 @@
 	AC_MSG_RESULT($HAVE_SCOTCH)
 	AM_CONDITIONAL([SCOTCH],[test x$HAVE_SCOTCH = xyes])
-	
+
 	dnl scotch libraries
 	if test "x$HAVE_SCOTCH" = "xyes"; then
@@ -721,5 +726,5 @@
 	AC_ARG_WITH([esmf-dir],
 		AS_HELP_STRING([--with-esmf-dir=DIR], [esmf root directory.]),
-		[ESMF_ROOT=$withval],[ESMF_ROOT="no"]) 
+		[ESMF_ROOT=$withval],[ESMF_ROOT="no"])
 
 	dnl Check whether esmf is enabled
@@ -734,5 +739,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_ESMF)
-	
+
 	dnl esmf headers and libraries
 	if test "x$HAVE_ESMF" == "xyes"; then
@@ -745,8 +750,47 @@
 	AM_CONDITIONAL([ESMF], [test x$HAVE_ESMF = xyes])
 	dnl }}}
+	dnl codipack{{{
+	AC_ARG_WITH([codipack-dir],
+		AS_HELP_STRING([--with-codipack-dir=DIR], [CoDiPack root directory.]),
+		[CODIPACK_ROOT=$withval],[CODIPACK_ROOT="no"])
+
+	dnl Check whether codipack is enabled
+	AC_MSG_CHECKING([for CoDiPack])
+	if test "x$CODIPACK_ROOT" = "xno" ; then
+		HAVE_CODIPACK=no
+	else
+		HAVE_CODIPACK=yes
+		if ! test -d "$CODIPACK_ROOT"; then
+			AC_MSG_ERROR([codipack directory provided ($CODIPACK_ROOT) does not exist]);
+		fi
+	fi
+	AC_MSG_RESULT($HAVE_CODIPACK)
+
+	dnl codipack headers and libraries
+	if test "x$HAVE_CODIPACK" == "xyes"; then
+		CODIPACKINCL="-I$CODIPACK_ROOT/include"
+		AC_DEFINE([_HAVE_CODIPACK_],[1],[with codipack in ISSM src])
+		AC_DEFINE([_HAVE_AD_],[1],[with AD in ISSM src])
+		AC_SUBST([CODIPACKINCL])
+	fi
+	AM_CONDITIONAL([CODIPACK], [test x$HAVE_CODIPACK = xyes])
+   AM_COND_IF(CODIPACK,[CXXFLAGS+=" -std=c++11"])
+	dnl }}}
+	dnl tapeallocation {{{
+	AC_ARG_ENABLE([tape-alloc], dnl feature
+		AS_HELP_STRING([--enable-tape-alloc],[turn tape allocation support on]),
+		[enable_tape_alloc=$enableval], [enable_tape_alloc=no])
+
+	dnl check whether enabled
+	AC_MSG_CHECKING(for tape memory allocation)
+	if test "x$enable_tape_alloc" = xyes; then
+		AC_DEFINE([_AD_TAPE_ALLOC_],[1],[Macro to enable a priori tape allocation for AD])
+	fi
+	AC_MSG_RESULT($enable_tape_alloc)
+	dnl }}}
 	dnl adolc{{{
 	AC_ARG_WITH([adolc-dir],
 		AS_HELP_STRING([--with-adolc-dir=DIR], [adolc root directory.]),
-		[ADOLC_ROOT=$withval],[ADOLC_ROOT="no"]) 
+		[ADOLC_ROOT=$withval],[ADOLC_ROOT="no"])
 
 	dnl Check whether adolc is enabled
@@ -761,5 +805,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_ADOLC)
-	
+
 	dnl adolc headers and libraries
 	if test "x$HAVE_ADOLC" == "xyes"; then
@@ -773,11 +817,11 @@
 	fi
 	AM_CONDITIONAL([ADOLC], [test x$HAVE_ADOLC = xyes])
-        AM_COND_IF(ADOLC,[CXXFLAGS+=" -std=c++11"])
+   AM_COND_IF(ADOLC,[CXXFLAGS+=" -std=c++11"])
 	dnl }}}
 	dnl adolc-version{{{
 	AC_ARG_WITH([adolc-version],
 		AS_HELP_STRING([--with-adolc-version=number], [adolc version.]),
-		[ADOLC_VERSION=$withval],[ADOLC_VERSION=2]) 
-	AC_MSG_CHECKING(for adolc-version) 
+		[ADOLC_VERSION=$withval],[ADOLC_VERSION=2])
+	AC_MSG_CHECKING(for adolc-version)
 
 	AC_DEFINE_UNQUOTED([_ADOLC_VERSION_],$ADOLC_VERSION,[ADOLC version])
@@ -787,5 +831,5 @@
 	AC_ARG_WITH([adic2-dir],
 	  AS_HELP_STRING([--with-adic2-dir=DIR], [adic2 root directory.]),
-	  [ADIC2_ROOT=$withval],[ADIC2_ROOT="no"]) 
+	  [ADIC2_ROOT=$withval],[ADIC2_ROOT="no"])
 
 	dnl Check whether adic2 is enabled
@@ -815,5 +859,5 @@
 	  AS_HELP_STRING([--with-atlas-dir=DIR],[atlas root directory]),
 	  [ATLAS_ROOT=$withval],[ATLAS_ROOT="no"])
-			  
+
 	dnl Check whether atlas is enabled
 	AC_MSG_CHECKING(for atlas and cblas libraries)
@@ -836,8 +880,8 @@
 			;;
 			*linux*)
-			ATLASLIB=-L"$ATLAS_ROOT/lib -lcblas -latlas -lm " 
+			ATLASLIB=-L"$ATLAS_ROOT/lib -lcblas -latlas -lm "
 			;;
 			*darwin*)
-			ATLASLIB=-L"$ATLAS_ROOT/lib -lcblas -latlas -lm" 
+			ATLASLIB=-L"$ATLAS_ROOT/lib -lcblas -latlas -lm"
 			;;
 		esac
@@ -849,5 +893,5 @@
 	AC_ARG_WITH([gsl-dir],
 	  AS_HELP_STRING([--with-gsl-dir=DIR], [gsl root directory.]),
-	  [GSL_ROOT=$withval],[GSL_ROOT="no"]) 
+	  [GSL_ROOT=$withval],[GSL_ROOT="no"])
 
 	dnl Check whether gsl is enabled
@@ -862,5 +906,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_GSL)
-	
+
 	dnl gsl headers and libraries
 	if test "x$HAVE_GSL" == "xyes"; then
@@ -877,8 +921,8 @@
 	AM_CONDITIONAL([GSL], [test x$HAVE_GSL = xyes])
 	dnl }}}
-	dnl adjoinable-mpi{{{
+	dnl ampi (ADOLC){{{
 	AC_ARG_WITH([ampi-dir],
 	  AS_HELP_STRING([--with-ampi-dir=DIR], [adjoinable mpi root directory.]),
-	  [AMPI_ROOT=$withval],[AMPI_ROOT="no"]) 
+	  [AMPI_ROOT=$withval],[AMPI_ROOT="no"])
 
 	dnl Check whether ampi is enabled
@@ -893,5 +937,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_AMPI)
-	
+
 	dnl ampi headers and libraries
 	if test "x$HAVE_AMPI" == "xyes"; then
@@ -912,8 +956,73 @@
 	AM_CONDITIONAL([AMPI], [test x$HAVE_AMPI = xyes])
 	dnl }}}
+	dnl adjointmpi (CoDiPack){{{
+	AC_ARG_WITH([adjointmpi-dir],
+	  AS_HELP_STRING([--with-adjointmpi-dir=DIR], [adjoinable mpi root directory.]),
+	  [ADJOINTMPI_ROOT=$withval],[ADJOINTMPI_ROOT="no"])
+
+	dnl Check whether adjointmpi is enabled
+	AC_MSG_CHECKING([for adjointmpi])
+	if test "x$ADJOINTMPI_ROOT" = "xno" ; then
+		HAVE_ADJOINTMPI=no
+	else
+		HAVE_ADJOINTMPI=yes
+		if ! test -d "$ADJOINTMPI_ROOT"; then
+			AC_MSG_ERROR([adjointmpi directory provided ($ADJOINTMPI_ROOT) does not exist]);
+		fi
+	fi
+	AC_MSG_RESULT($HAVE_ADJOINTMPI)
+
+	dnl adjointmpi headers and libraries
+	if test "x$HAVE_ADJOINTMPI" == "xyes"; then
+		if test "x$CODIPACK_ROOT" == "xno"; then
+			AC_MSG_ERROR([cannot run adjoint mpi without CoDiPack]);
+		fi
+		ADJOINTMPIINCL="-I$ADJOINTMPI_ROOT/include"
+		ADJOINTMPILIB="-L$ADJOINTMPI_ROOT/lib  -lAMPI"
+		dnl Also set _HAVE_AMPI_, because the interface is (almost) the
+		dnl same as for adjoinable mpi...
+		AC_DEFINE([_HAVE_AMPI_],[1],[with adjoint mpi in ISSM src])
+		AC_DEFINE([_HAVE_ADJOINTMPI_],[1],[with adjoint mpi in ISSM src])
+		AC_SUBST([ADJOINTMPIINCL])
+		AC_SUBST([ADJOINTMPILIB])
+	fi
+	AM_CONDITIONAL([ADJOINTMPI], [test x$HAVE_ADJOINTMPI = xyes])
+	dnl }}}
+	dnl medipack (CoDiPack, ADOLC dev){{{
+	AC_ARG_WITH([medipack-dir],
+	  AS_HELP_STRING([--with-medipack-dir=DIR], [MeDiPack root directory.]),
+	  [MEDIPACK_ROOT=$withval],[MEDIPACK_ROOT="no"])
+
+	dnl Check whether medipack is enabled
+	AC_MSG_CHECKING([for medipack])
+	if test "x$MEDIPACK_ROOT" = "xno" ; then
+		HAVE_MEDIPACK=no
+	else
+		HAVE_MEDIPACK=yes
+		if ! test -d "$MEDIPACK_ROOT"; then
+			AC_MSG_ERROR([medipack directory provided ($MEDIPACK_ROOT) does not exist]);
+		fi
+	fi
+	AC_MSG_RESULT($HAVE_MEDIPACK)
+
+	dnl medipack headers and libraries
+	if test "x$HAVE_MEDIPACK" == "xyes"; then
+		if test "x$CODIPACK_ROOT" == "xno"; then
+			AC_MSG_ERROR([cannot run MeDiPack without CoDiPack]);
+		fi
+		MEDIPACKINCL="-I$MEDIPACK_ROOT/include -I$MEDIPACK_ROOT/src"
+		dnl Also set _HAVE_AMPI_, because the interface is (almost) the
+		dnl same as for adjoinable mpi...
+		AC_DEFINE([_HAVE_AMPI_],[1],[with adjoint mpi in ISSM src])
+		AC_DEFINE([_HAVE_MEDIPACK_],[1],[with MeDiPack in ISSM src])
+		AC_SUBST([MEDIPACKINCL])
+	fi
+	AM_CONDITIONAL([MEDIPACK], [test x$HAVE_MEDIPACK = xyes])
+
+	dnl }}}
 	dnl rose{{{
 	AC_ARG_WITH([rose-dir],
 	  AS_HELP_STRING([--with-rose-dir=DIR], [rose root directory.]),
-	  [ROSE_ROOT=$withval],[ROSE_ROOT="no"]) 
+	  [ROSE_ROOT=$withval],[ROSE_ROOT="no"])
 
 	dnl Check whether rose is enabled
@@ -941,5 +1050,5 @@
 	dnl mpi{{{
 	AC_MSG_CHECKING(for mpi)
-	
+
 	AC_ARG_WITH([mpi-include],
 	  AS_HELP_STRING([--with-mpi-include=DIR],[mpi include directory, necessary for parallel build]),
@@ -954,5 +1063,5 @@
 	  [MPI_LIBFLAGS=$withval],[MPI_LIBFLAGS=""])
 
-	
+
 	if test -z "$MPI_INCLUDE" ; then
 		HAVE_MPI=no
@@ -980,5 +1089,5 @@
 		if  test x$IS_WINDOWS = xyes; then
 			MPIINCL=/I"$MPI_INCLUDE"
-		else 
+		else
 			MPIINCL=-I"$MPI_INCLUDE"
 		fi
@@ -996,5 +1105,5 @@
 	  AS_HELP_STRING([--with-petsc-dir=DIR],[PETSc root directory, necessary for parallel build]),
 	  [PETSC_ROOT=$withval],[PETSC_ROOT="no"])
-		
+
 	dnl Check whether petsc is enabled
 	AC_MSG_CHECKING([for petsc])
@@ -1033,5 +1142,5 @@
 			AC_MSG_RESULT(no)
 		fi
-	
+
 		AC_ARG_WITH([petsc-arch],
 		  AS_HELP_STRING([--with-petsc-arch=DIR],[PETSc arch, necessary for PETSc < 3.0]),
@@ -1050,5 +1159,5 @@
 		 PETSCINCL+=" $PETSC_ROOT/include/$PETSC_ARCH"
 		fi
-		
+
 		case "${host_os}" in
 				*cygwin*)
@@ -1069,5 +1178,5 @@
 				if test "x$host_os_version" = "x3.0.101-0.31.1_1.0502.8394-cray_gem_s" ; then
 					PETSCLIB="-L$PETSC_ROOT/lib -lcraypetsc_gnu_real -lmetis"
-				fi 
+				fi
 				;;
 				*darwin*)
@@ -1122,8 +1231,8 @@
 
 			if test "$METIS_VERSION" = "4" ; then
-				METISINCL=-I"$METIS_ROOT/Lib" 
+				METISINCL=-I"$METIS_ROOT/Lib"
 				case "${host_os}" in
 					*cygwin*)
-					METISINCL="/I`cygpath -m $METIS_ROOT/Lib`" 
+					METISINCL="/I`cygpath -m $METIS_ROOT/Lib`"
 					METISLIB="-Wl,/link -Wl,/LIBPATH:`cygpath -m $METIS_ROOT` -Wl,libmetis.lib"
 					;;
@@ -1150,5 +1259,5 @@
 					;;
 				esac
-				METISINCL=-I"$METIS_ROOT/include" 
+				METISINCL=-I"$METIS_ROOT/include"
 				AC_DEFINE([_METIS_VERSION_],[5],[ Metis version number])
 			fi
@@ -1164,5 +1273,5 @@
 	AC_ARG_WITH([tao-dir],
 		AS_HELP_STRING([--with-tao-dir=DIR], [tao root directory.]),
-		[TAO_ROOT=$withval],[TAO_ROOT="no"]) 
+		[TAO_ROOT=$withval],[TAO_ROOT="no"])
 
 	dnl Check whether tao is enabled
@@ -1199,5 +1308,5 @@
 	AC_ARG_WITH([m1qn3-dir],
 		AS_HELP_STRING([--with-m1qn3-dir=DIR], [m1qn3 root directory.]),
-		[M1QN3_ROOT=$withval],[M1QN3_ROOT="no"]) 
+		[M1QN3_ROOT=$withval],[M1QN3_ROOT="no"])
 
 	dnl Check whether m1qn3 is enabled
@@ -1212,8 +1321,8 @@
 	fi
 	AC_MSG_RESULT($HAVE_M1QN3)
-	
+
 	dnl m1qn3 headers and libraries
 	if test "x$HAVE_M1QN3" == "xyes"; then
-	  M1QN3LIB="$M1QN3_ROOT/libm1qn3.a $M1QN3_ROOT//libddot.a"
+	  M1QN3LIB="$M1QN3_ROOT/libm1qn3.a $M1QN3_ROOT/libddot.a"
 	  AC_DEFINE([_HAVE_M1QN3_],[1],[with M1QN3 in ISSM src])
 	  AC_SUBST([M1QN3LIB])
@@ -1223,5 +1332,5 @@
 	AC_ARG_WITH([proj4-dir],
 		AS_HELP_STRING([--with-proj4-dir=DIR], [proj4 root directory.]),
-		[PROJ4_ROOT=$withval],[PROJ4_ROOT="no"]) 
+		[PROJ4_ROOT=$withval],[PROJ4_ROOT="no"])
 
 	dnl Check whether proj4 is enabled
@@ -1236,5 +1345,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_PROJ4)
-	
+
 	dnl proj4 headers and libraries
 	if test "x$HAVE_PROJ4" == "xyes"; then
@@ -1251,5 +1360,5 @@
 	  AS_HELP_STRING([--with-slepc-dir=DIR],[slepc root directory]),
 	  [SLEPC_ROOT=$withval],[SLEPC_ROOT="no"])
-			  
+
 	dnl Check whether slepc is enabled
 	AC_MSG_CHECKING([for slepc])
@@ -1263,5 +1372,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_SLEPC)
-	
+
 	dnl slepc headers and libraries
 	if test "x$HAVE_SLEPC" == "xyes"; then
@@ -1277,5 +1386,5 @@
 	  AS_HELP_STRING([--with-shapelib-dir=DIR], [shapelib root directory]),
 	  [SHAPELIB_ROOT=$withval],[SHAPELIB_ROOT="no"])
-			  
+
 	dnl Check whether shapelib is enabled
 	AC_MSG_CHECKING([for shapelib])
@@ -1289,5 +1398,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_SHAPELIB)
-	
+
 	dnl shapelib headers and libraries
 	if test "x$HAVE_SHAPELIB" == "xyes"; then
@@ -1309,5 +1418,5 @@
 	  AS_HELP_STRING([--with-scalapack-lib=LIBS],[scalapack libraries to include]),
 	  [SCALAPACKLIB=$withval],[SCALAPACKLIB="no"])
-			  
+
 	dnl Check whether scalapack is enabled
 	AC_MSG_CHECKING([for scalapack])
@@ -1329,5 +1438,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_SCALAPACK)
-	
+
 	dnl scalapack headers and libraries
 	if test "x$HAVE_SCALAPACK" = "xyes"; then
@@ -1340,5 +1449,5 @@
 	  AS_HELP_STRING([--with-blas-lapack-dir=DIR],[blas-lapack root directory]),
 	  [BLASLAPACK_ROOT=$withval],[BLASLAPACK_ROOT="no"])
-			  
+
 	dnl Check whether blas-lapack is enabled
 	AC_MSG_CHECKING([for blas-lapack])
@@ -1352,5 +1461,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_BLASLAPACK)
-	
+
 	dnl blas-lapack headers and libraries
 	if test "x$HAVE_BLASLAPACK" == "xyes"; then
@@ -1362,8 +1471,8 @@
 		  ;;
 		*linux*)
-		  BLASLAPACKLIB=-L"$BLASLAPACK_ROOT/lib -lflapack -lfblas " 
+		  BLASLAPACKLIB=-L"$BLASLAPACK_ROOT/lib -lflapack -lfblas "
 		  ;;
 		*darwin*)
-		  BLASLAPACKLIB=-L"$BLASLAPACK_ROOT/lib -lflapack -lfblas " 
+		  BLASLAPACKLIB=-L"$BLASLAPACK_ROOT/lib -lflapack -lfblas "
 		  ;;
 		esac
@@ -1393,17 +1502,17 @@
 	dnl plapack{{{
 	AC_MSG_CHECKING(for plapack)
-	
+
 	AC_ARG_WITH([plapack-lib],
 	  AS_HELP_STRING([--with-plapack-lib = lib],[plapack library]),
 	  [PLAPACK_LIB=$withval],[PLAPACK_LIB=""])
-	
+
 	AC_ARG_WITH([plapack-include],
 			  AS_HELP_STRING([--with-plapack-include = include],
 							 [plapack include ]),
 			  [PLAPACK_INCLUDE=$withval],[PLAPACK_INCLUDE=""])
-	  
+
 	if test -n "$PLAPACK_LIB"; then
 		if test -n "$PLAPACK_INCLUDE"; then
-		
+
 			HAVE_PLAPACK=yes
 			PLAPACKINCL="$PLAPACK_INCLUDE"
@@ -1424,5 +1533,5 @@
 	  AS_HELP_STRING([--with-mumps-dir=DIR],[mumps root directory]),
 	  [MUMPS_ROOT=$withval],[MUMPS_ROOT="no"])
-			  
+
 	dnl Check whether mumps is enabled
 	AC_MSG_CHECKING([for mumps])
@@ -1436,5 +1545,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_MUMPS)
-	
+
 	dnl mumps headers and libraries
 	if test "x$HAVE_MUMPS" == "xyes"; then
@@ -1455,5 +1564,5 @@
 	if test "x$HAVE_MUMPS" != "xyes"; then
 	AC_MSG_CHECKING(for mumps2 (stand alone))
-	
+
 	AC_ARG_WITH([mumps2-include],
 	  AS_HELP_STRING([--with-mumps2-include=DIR],[mumps2 include directory, necessary for parallel build]),
@@ -1464,5 +1573,5 @@
 	  [MUMPS_LIBFLAGS=$withval],[MUMPS_LIBFLAGS=""])
 
-	
+
 	if test -z "$MUMPS_INCLUDE" ; then
 		HAVE_MUMPS=no
@@ -1490,5 +1599,5 @@
 		AS_HELP_STRING([--with-blacs-dir=DIR],[blacs root directory]),
 			  [BLACS_ROOT=$withval],[BLACS_ROOT="no"])
-			  
+
 	dnl Check whether blacs is enabled
 	AC_MSG_CHECKING([for blacs])
@@ -1502,5 +1611,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_BLACS)
-	
+
 	dnl blacs headers and libraries
 	if test "x$HAVE_BLACS" == "xyes"; then
@@ -1516,5 +1625,5 @@
 	  AS_HELP_STRING([--with-hypre-dir=DIR],[hypre root directory]),
 			  [HYPRE_ROOT=$withval],[HYPRE_ROOT="no"])
-			  
+
 	dnl Check whether hypre is enabled
 	AC_MSG_CHECKING([for hypre])
@@ -1590,5 +1699,5 @@
 		fi
 	  dnl }}}
-dnl superlu{{{ 
+dnl superlu{{{
 	AC_ARG_WITH([superlu-dir],
 				AS_HELP_STRING([--with-superlu-dir=DIR],[superlu root directory]),
@@ -1606,5 +1715,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_SUPERLU)
-	
+
 	dnl superlu headers and libraries
 	if test "x$HAVE_SUPERLU" == "xyes"; then
@@ -1616,5 +1725,5 @@
 	 fi
 	 dnl }}}
-dnl spooles{{{ 
+dnl spooles{{{
 	AC_ARG_WITH([spooles-dir],
 				AS_HELP_STRING([--with-spooles-dir=DIR],[spooles root directory]),
@@ -1632,5 +1741,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_SPOOLES)
-	
+
 	dnl spooles headers and libraries
 	if test "x$HAVE_SPOOLES" == "xyes"; then
@@ -1642,5 +1751,5 @@
 	 fi
 	 dnl }}}
-dnl pastix{{{ 
+dnl pastix{{{
 	AC_ARG_WITH([pastix-dir],
 				AS_HELP_STRING([--with-pastix-dir=DIR],[pastix root directory]),
@@ -1658,5 +1767,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_PASTIX)
-	
+
 	dnl pastix headers and libraries
 	if test "x$HAVE_PASTIX" == "xyes"; then
@@ -1672,5 +1781,5 @@
 	  AS_HELP_STRING([--with-ml-dir=DIR],[ml root directory]),
 			  [ML_ROOT=$withval],[ML_ROOT="no"])
-			  
+
 	dnl Check whether ml is enabled
 	AC_MSG_CHECKING([for ml])
@@ -1684,5 +1793,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_ML)
-	
+
 	dnl ml headers and libraries
 	if test "x$HAVE_ML" == "xyes"; then
@@ -1698,5 +1807,5 @@
 		  AS_HELP_STRING([--with-umfpack-dir=DIR],[UMFPACK root directory]),
 					[UMFPACK_ROOT=$withval],[UMFPACK_ROOT="no"])
-			  
+
 	dnl Check whether umfpack is enabled
 	AC_MSG_CHECKING([for umfpack])
@@ -1710,5 +1819,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_UMFPACK)
-	
+
 	dnl umfpack headers and libraries
 	if test "x$HAVE_UMFPACK" == "xyes"; then
@@ -1738,6 +1847,6 @@
 		AC_ARG_WITH([math77-dir],
 					AS_HELP_STRING([--with-math77-dir=DIR], [math77 root directory.]),
-					[MATH77_ROOT=$withval],[MATH77_ROOT="no"]) 
-		  
+					[MATH77_ROOT=$withval],[MATH77_ROOT="no"])
+
 	dnl Check whether math77 is enabled
 	AC_MSG_CHECKING([for math77])
@@ -1751,5 +1860,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_MATH77)
-	
+
 	dnl math77 headers and libraries
 	if test "x$HAVE_MATH77" == "xyes"; then
@@ -1762,5 +1871,5 @@
 	AC_ARG_WITH([fortran],
 		AS_HELP_STRING([--with-fortran = YES], [do we compile fortran code (default is yes)]),
-		[FORTRAN=$withval],[FORTRAN=yes]) 
+		[FORTRAN=$withval],[FORTRAN=yes])
 	AC_MSG_CHECKING(for fortran compilation)
 	if test "x$FORTRAN" = "xyes"; then
@@ -1830,5 +1939,5 @@
 	AC_ARG_WITH([meteoio-dir],
 	  AS_HELP_STRING([--with-meteoio-dir=DIR], [use meteoio in conjunction with snowpack model.]),
-	  [METEOIO_ROOT=$withval],[METEOIO_ROOT="no"]) 
+	  [METEOIO_ROOT=$withval],[METEOIO_ROOT="no"])
 
 	dnl Check whether meteoio is enabled
@@ -1843,5 +1952,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_METEOIO)
-	
+
 	dnl meteoio headers and libraries
 	if test "x$HAVE_METEOIO" == "xyes"; then
@@ -1858,5 +1967,5 @@
 	AC_ARG_WITH([snowpack-dir],
 	  AS_HELP_STRING([--with-snowpack-dir=DIR], [use snowpack for surface mass balance model.]),
-	  [SNOWPACK_ROOT=$withval],[SNOWPACK_ROOT="no"]) 
+	  [SNOWPACK_ROOT=$withval],[SNOWPACK_ROOT="no"])
 
 	dnl Check whether snowpack is enabled
@@ -1871,5 +1980,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_SNOWPACK)
-	
+
 	dnl snowpack headers and libraries
 	if test "x$HAVE_SNOWPACK" == "xyes"; then
@@ -1886,5 +1995,5 @@
 	AC_ARG_WITH([neopz-dir],
 		AS_HELP_STRING([--with-neopz-dir=DIR], [neopz root directory.]),
-		[NEOPZ_ROOT=$withval],[NEOPZ_ROOT="no"]) 
+		[NEOPZ_ROOT=$withval],[NEOPZ_ROOT="no"])
 
 	dnl Check whether neopz is enabled
@@ -1899,5 +2008,5 @@
 	fi
 	AC_MSG_RESULT($HAVE_NEOPZ)
-	
+
 	dnl neopz headers and libraries
 	if test "x$HAVE_NEOPZ" == "xyes"; then
@@ -1938,5 +2047,5 @@
 	AC_ARG_WITH([bamg],
 		AS_HELP_STRING([--with-bamg = YES],[compile with bamg capabilities (default is yes)]),
-		[BAMG=$withval],[BAMG=yes]) 
+		[BAMG=$withval],[BAMG=yes])
 	AC_MSG_CHECKING(for bamg capability compilation)
 
@@ -1952,5 +2061,5 @@
 	AC_ARG_WITH([ocean],
 		AS_HELP_STRING([--with-ocean = YES],[compile with ice/ocean coupling (default is no)]),
-		[OCEAN=$withval],[OCEAN=no]) 
+		[OCEAN=$withval],[OCEAN=no])
 	AC_MSG_CHECKING(for ice/ocean capability compilation)
 
@@ -1966,5 +2075,5 @@
 	AC_ARG_WITH([kml],
 		AS_HELP_STRING([--with-kml = YES],[compile with kml capabilities (default is no)]),
-		[KML=$withval],[KML=no]) 
+		[KML=$withval],[KML=no])
 	AC_MSG_CHECKING(for kml capability compilation)
 
@@ -1980,5 +2089,5 @@
 	AC_ARG_WITH([kriging],
 		AS_HELP_STRING([--with-kriging = YES],[compile with kriging capabilities (default is yes)]),
-		[KRIGING=$withval],[KRIGING=yes]) 
+		[KRIGING=$withval],[KRIGING=yes])
 	AC_MSG_CHECKING(for kriging capability compilation)
 
@@ -1997,5 +2106,5 @@
 	AC_ARG_WITH([ios],
 		AS_HELP_STRING([--with-ios = YES], [compile with iOS capabilities (default is no, alternatives are yes)]),
-		[IOS=$withval],[IOS=no]) 
+		[IOS=$withval],[IOS=no])
 	AC_MSG_CHECKING(for iOS compilation)
 
@@ -2016,5 +2125,5 @@
 	AC_ARG_WITH([android],
 		AS_HELP_STRING([--with-android = EXE], [compile with android capabilities (default is no, alternatives are exe and jni)]),
-		[ANDROID=$withval],[ANDROID=no]) 
+		[ANDROID=$withval],[ANDROID=no])
 	AC_MSG_CHECKING(for android capability compilation)
 
@@ -2043,7 +2152,7 @@
 	AC_ARG_WITH([android-ndk],
 	  AS_HELP_STRING([--with-android-ndk=DIR], [android-ndk root directory.]),
-	  [ANDROID_NDK_ROOT=$withval],[ANDROID_NDK_ROOT=""]) 
+	  [ANDROID_NDK_ROOT=$withval],[ANDROID_NDK_ROOT=""])
 	AC_MSG_CHECKING(with android ndk)
-	
+
 	if test -d "$ANDROID_NDK_ROOT"; then
 		dnl defaults
@@ -2061,8 +2170,8 @@
 	dnl other options
 	dnl optimization{{{
-	dnl bypass standard optimization -g -O2 ? 
+	dnl bypass standard optimization -g -O2 ?
 	AC_ARG_WITH([cxxoptflags],
 	  AS_HELP_STRING([--with-cxxoptflags = CXXOPTFLAGS], [optimization using CXX flags, ex: --with-cxxoptflags=-march=opteron -O3]),
-	  [CXXOPTFLAGS=$withval],[CXXOPTFLAGS="-g -O2 -fPIC"]) 
+	  [CXXOPTFLAGS=$withval],[CXXOPTFLAGS="-g -O2 -fPIC"])
 	AC_MSG_CHECKING(for c++ optimization flags)
 	AC_SUBST([CXXOPTFLAGS])
@@ -2079,5 +2188,5 @@
 	MULTITHREADINLIB=""
 	if test "$NUMTHREADS_VALUE" != "1"; then
-		
+
 		MULTITHREADINGLIB="-lpthread -lrt"
 		case "${host_os}" in
@@ -2094,12 +2203,19 @@
 		AC_DEFINE([_MULTITHREADING_],[1],[with numthreads enabled])
 	fi
+	dnl check that it is an integer
+	if [[ "$NUMTHREADS_VALUE" -eq   "$NUMTHREADS_VALUE" 2> /dev/null ]] ; then
+	 dnl cool we have an integer
+	 :
+	else
+	 AC_MSG_ERROR([Number of threads provided ($NUMTHREADS_VALUE) is not an integer]);
+	fi
 	AC_DEFINE_UNQUOTED([_NUMTHREADS_],[$NUMTHREADS_VALUE],[number of threads])
 	AC_SUBST([MULTITHREADINGLIB])
-	AC_MSG_RESULT($NUMTHREADS_VALUE) 
+	AC_MSG_RESULT($NUMTHREADS_VALUE)
 	dnl }}}
 	dnl 64bit {{{
 	AC_ARG_WITH([64bit-indices],
 	  AS_HELP_STRING([--with-64bit-indices = bool], [use 64 bit integers, default 0, ex: --with-64bit-indices=1]),
-	  [USE_64BIT_INDICES=$withval],[USE_64BIT_INDICES=0]) 
+	  [USE_64BIT_INDICES=$withval],[USE_64BIT_INDICES=0])
 	AC_MSG_CHECKING(for 64 bit indices)
 
@@ -2132,5 +2248,5 @@
 			  AC_MSG_ERROR([need fortran compiler to compile GiaIvins (or use --without-GiaIvins )]);
 		 fi
-			
+
        dnl check that fortran is provided if Love is on
 		 if test "$HAVE_LOVE" = "yes" &&  test "$HAVE_FORTRAN" = "no" ; then
@@ -2142,5 +2258,5 @@
 				AC_MSG_ERROR([need mpi if using the metis partitioner!]);
 		  fi
-		
+
 		dnl check that if we run adolc, we don't compile krigging.exe
 		if test "$HAVE_ADOLC" = "yes"  && test "$HAVE_KRIGING" = "yes" ; then
@@ -2151,4 +2267,10 @@
 			AC_MSG_ERROR([cannot compile ISSM with both PETSc and adolc]);
 		fi
+		if test "$HAVE_ADOLC" = "yes"  && test "$HAVE_CODIPACK" = "yes" ; then
+			AC_MSG_ERROR([cannot compile ISSM with both ADOLC and CoDiPack]);
+		fi
+		if test "$HAVE_ADJOINTMPI" = "yes"  && test "$HAVE_MEDIPACK" = "yes" ; then
+			AC_MSG_ERROR([cannot compile ISSM with both MeDiPack and AdjointMPI]);
+		fi
 		dnl check that if we run meteoio, we have snowpack also
 		if test "$HAVE_METEOIO" = "yes"  && test "$HAVE_SNOWPACK" = "no" ; then
